local _G = getfenv(0)
local core
local name, localizedname = GetAddOnInfo("YurrCombatLog")
core = DongleStub("Dongle-1.2"):New(name)
_G.YurrCombatLog = core
local L = _G.YurrCombatLogLocale
if tekDebug then core:EnableDebug(1, tekDebug:GetFrame("YurrCombatLog-Log")) end
local CombatLogQuickButtonFrameProgressBar
local CombatLogUpdateFrame = CreateFrame("Frame", "CombatLogUpdateFrame", UIParent)

local db
local schools = {
	[1] = SPELL_SCHOOL0_NAME, -- physical
	[2] = SPELL_SCHOOL1_NAME, -- holy
	[4] = SPELL_SCHOOL2_NAME, -- fire
	[8] = SPELL_SCHOOL3_NAME, -- nature
	[16] = SPELL_SCHOOL4_NAME, -- frost
	[20] = SPELL_SCHOOL4_NAME..SPELL_SCHOOL2_NAME, -- frostfire
	[32] = SPELL_SCHOOL5_NAME, -- shadow
	[40] = SPELL_SCHOOL3_NAME..SPELL_SCHOOL5_NAME, -- natureshadow
	[64] = SPELL_SCHOOL6_NAME -- arcane
}

function core:Initialize()
	
	local cmd = self:InitializeSlashCommand("YurrCombatLog slash commands", "yurrcombatlog", "ycl")
	cmd:RegisterSlashHandler("Open the options menu", "^$", "showoptionsgui")

	if YurrCombatLogDB.namespaces then YurrCombatLogDB = nil end
    self.db = self:InitializeDB("YurrCombatLogDB", {
		global = {
			outputFrame = "ChatFrame3",
			unitColors = {
				[1297] = "8080FF", -- self
				[4991] = "804D26", -- pet
				[1394] = "A6FFA6", -- party
				[1396] = "FF7038", -- raid
				[9087] = "404080", -- guardian
				[131072] = "CC54D9", -- focus
				[20334] = "FF75FF", -- enemy players/npcs
				[3864] = "FFFFFF", -- outsider
				--[[[1297] = "8080FF", -- self
				[4369] = "804D26", -- pet
				[1298] = "A6FFA6", -- party
				[1300] = "FF7038", -- raid
				[9087] = "404080", -- guardian
				[131072] = "CC54D9", -- focus
				[20334] = "FF75FF", -- enemy players/npcs
				[1304] = "FFFFFF", -- outsider]]
			},
			spellColors = {
				[1] = "FFFFFF", -- physical
				[2] = "FFFF4D", -- holy
				[4] = "FF262E", -- fire
				[8] = "66FF66", -- fire
				[16] = "4D4DE6", -- frost
				[20] = "A63B96", -- frostfire
				[32] = "FFB3FF", -- shadow
				[40] = "B3D9B3", -- natureshadow
				[64] = "BFBFBF", -- arcane
			},
			otherColors = {
				heal = "FFFF4D",
				miss = "FF8080", -- unused for the moment
				buff = "33FF33",
				debuff = "FF3333",
				skill = "FFFF66",
				timestampColor = "737373",
			},
			braceSrcUnit = true,
			leftSrcBrace = "[",
			rightSrcBrace = "]",
			colorSrc = true,
			colorSrcBraces = false,
			leftSrcBraceColor = "FF75FF",
			rightSrcBraceColor = "FF75FF",
			
			prefix = true,
			colorPrefix = true,
			["++"] = "++",
			["--"] = "--",
			["-+"] = "-+",
			
			braceSpell = false,
			leftSpellBrace = "[",
			rightSpellBrace = "]",
			colorSpell = true,
			colorSpellBraces = false,
			leftSpellBraceColor = "FF75FF",
			rightSpellBraceColor = "FF75FF",
			
			spellSchools = false,
			swingSchools = false,
			rangedSchools = false,
			
			suffixString = true,
			resultInSuffix = true,
			
			braceDestUnit = true,
			leftDestBrace = "[",
			rightDestBrace = "]",
			colorDest = true,
			colorDestBraces = false,
			leftDestBraceColor = "FF75FF",
			rightDestBraceColor = "FF75FF",
			
			braceAmount = true,
			leftAmountBrace = "[",
			rightAmountBrace = "]",
			colorAmount = true,
			colorAmountBraces = false,
			leftAmountBraceColor = "FF75FF",
			rightAmountBraceColor = "FF75FF",
			braceAmountDots = true,
			leftAmountDotsBrace = "~",
			rightAmountDotsBrace = "~",
			colorAmountDotBraces = false,
			leftAmountDotBraceColor = "FF75FF",
			rightAmountDotBraceColor = "FF75FF",
			markCrits = true,
			leftCrit = "*",
			rightCrit = "*",
			
			overhealing = true,
			overkill = true,
			
			resultString = true,
			
			schoolText = false,
			colorSchoolText = true,
			braceSchoolText = false,
			colorSchoolTextBraces = false,
			schoolTextBraceLeft = "[",
			schoolTextBraceRight = "]",
			
			format = {
				ABSORB = "(A%d)",
				BLOCK = BLOCK,
				BLOCK_VALUE = "(B%d)",
				CRITICAL = L["Crit"],
				CRUSHING = L["Crush"],
				DEFLECT = DEFLECT,
				DODGE = DODGE,
				EVADE = L["Evade"],
				GLANCING = L["Glancing"],
				IMMUNE = SPELL_FAILED_IMMUNE,
				MISS = MISS,
				PARRY = PARRY,
				REFLECT = REFLECT,
				RESIST = "(R%d)",
				VULNERABILITY = "(V%d+)",
			},
		},
	}, "global")
    db = self.db[self.db:GetCurrentProfile()]
end

local function showoptionsgui()
    if not IsAddOnLoaded("TinyTipOptions") then
        local _, reason = LoadAddOn("TinyTipOptions")
        local _, title = GetAddOnInfo("TinyTipOptions")
        if (not title) then title = 'TinyTipOptions' end
        if reason then
            core:Print( title .. " (Enable) LoadOnDemand Error - " .. reason )
        else
            --self:Print( "Loaded " .. title)
        end
    end
    if (TinyTipOptions) then TinyTipOptions:Show() end
end

function core:Enable()
	core:RegisterEvent("COMBAT_LOG_EVENT")
	
	
	CombatLogQuickButtonFrameProgressBar = _G.CombatLogQuickButtonFrame_CustomProgressBar
	Blizzard_CombatLog_RefilterUpdate = function(...)
	   function Blizzard_CombatLog_RefilterUpdate()
		  local valid = CombatLogGetCurrentEntry(); -- CombatLogAdvanceEntry(0);
		  
		  -- Clear the combat log
		  local total = 0;
		  while (valid and total < COMBATLOG_LIMIT_PER_FRAME) do 
			 -- Log to the window
			 local text, r, g, b, a = CombatLog_OnEvent(Blizzard_CombatLog_CurrentSettings, CombatLogGetCurrentEntry());
			 local YCLtext = self:processEvent("COMBAT_LOG_EVENT", CombatLogGetCurrentEntry())
			 -- NOTE: be sure to pass in nil for the color id or the color id may override the r, g, b values for this message
			 COMBATLOG:AddMessage( text, r, g, b, nil, true );
			 _G[db.outputFrame]:AddMessage( YCLtext, 1, 1, 1, nil, true );
			 
			 -- count can be 
			 --  positive to advance from oldest to newest
			 --  negative to advance from newest to oldest
			 valid = CombatLogAdvanceEntry(-1)
			 total = total + 1;
		  end
		  
		  -- Show filtering progress bar
		  CombatLogQuickButtonFrameProgressBar:SetValue(CombatLogQuickButtonFrameProgressBar:GetValue() + total);
		  
		  if ( not valid or (CombatLogQuickButtonFrameProgressBar:GetValue() >= COMBATLOG_MESSAGE_LIMIT) ) then
			 CombatLogUpdateFrame.refiltering = false
			 CombatLogUpdateFrame:SetScript("OnUpdate", nil)
			 CombatLogQuickButtonFrameProgressBar:Hide();
		  end
	   end
	end
	
	local enabled, loadable = select(4, GetAddOnInfo("YurrCombatLogOptions"))
	if enabled and loadable then
		local hijack = CreateFrame("Frame", nil, InterfaceOptionsFrame)
		hijack:SetScript("OnShow", function()
			hijack:Hide()
			local _, reason = LoadAddOn("YurrCombatLogOptions")
			local _, title = GetAddOnInfo("YurrCombatLogOptions")
			if (not title) then title = 'YurrCombatLogOptions' end
			if reason then
				self:Print( title .. " (Enable) LoadOnDemand Error - " .. reason )
			end
		end)
	end
    _G.SlashCmdList["ycl"] = showoptionsgui
end

function core:AffiliationColor(flags)
	local color
	for mask in pairs( db.unitColors ) do
		if ( CombatLog_Object_IsA (flags, mask) )then
			color = db.unitColors[mask]
			break
		end
	end
	return color
end

function core:ColorSpellBySchool(school, aura, event)
	if event == "SPELL_AURA_REMOVED" or event == "SPELL_AURA_REMOVED_DOSE" then
		return db.otherColors.skill
	elseif aura == "BUFF" then
		return db.otherColors.buff
	elseif aura == "DEBUFF" then
		return db.otherColors.debuff
	elseif event == "SPELL_HEAL" or event == "SPELL_PERIODIC_HEAL" then
		return db.otherColors.heal
	else
		if not db.spellColors[school] and school ~= nil then self:Debug(1, "MISSING SPELLSCHOOL: " .. school) end
		return db.spellColors[school]-- or "FFFFFF"
	end
end

function core:DamageResult(resisted, blocked, absorbed, critical, glancing, crushing)

	local resultStr
	
	if ( resisted or blocked or absorbed or critical or glancing or crushing ) then
		
		if ( resisted ) then
			if ( resisted < 0 ) then	--Its really a vulnerability
				resultStr = format(db.format.VULNERABILITY, -resisted);
			else
				resultStr = format(db.format.RESIST, resisted);
			end
		end
		if ( blocked ) then
			if ( resultStr ) then
				resultStr = resultStr.." "..format(db.format.BLOCK_VALUE, blocked);
			else
				resultStr = format(db.format.BLOCK_VALUE, blocked);
			end
		end
		if ( absorbed ) then
			if ( resultStr ) then
				resultStr = resultStr.." "..format(db.format.ABSORB, absorbed);
			else
				resultStr = format(db.format.ABSORB, absorbed);
			end
		end
		if ( glancing ) then
			if ( resultStr ) then
				resultStr = resultStr.." "..db.format.GLANCING;
			else
				resultStr = db.format.GLANCING;
			end
		end
		if ( crushing ) then
			if ( resultStr ) then
				resultStr = resultStr.." "..db.format.CRUSHING;
			else
				resultStr = db.format.CRUSHING;
			end
		end
		if ( critical ) then
			local critString = db.format.CRITICAL;
			if ( spellId ) then
				critString = db.format.CRITICAL_SPELL;
			end
			if ( resultStr ) then
				resultStr = resultStr.." "..critString;
			else
				resultStr = critString;
			end
		end
	end
	
	return resultStr or ""

end

function core:COMBAT_LOG_EVENT(...)
	local t = self:processEvent(...)
	_G[db.outputFrame]:AddMessage(t)
end

function core:processEvent(...)
	self:Debug(1, ...)
	
	local event = select(3, ...)
	
	local actionString
	
	local srcUnitName = select(5, ...)
	local srcFlags = select(6, ...)
	local srcUnitNameString
	
	local prefixString
	
	local spellName
	local spellNameString
	
	local suffixString
	
	local destUnitName = select(8, ...)
	local destFlags = select(9, ...)
	local destUnitNameString
	
	local amount
	local overkill
	local overhealing
	local school
	local resisted
	local blocked
	local absorbed
	local critical
	local glancing
	local crushing
	local missType
	local amountMissed
	local powerType
	local extraSpellName
	local extraSchool
	local auraType
	local failedType
	local itemID
	local itemName
		
	local amountString
	local powerString
	local schoolStr
	local resultString
	
	local finalString
	
	if srcUnitName == UnitName("player") then srcUnitName = UNIT_YOU end
	if destUnitName == UnitName("player") then destUnitName = UNIT_YOU end
	
	local base = 9
	local offset
	
	-- Prepare strings
	local prefix = strsub(event, 1, 5)
	local suffix = strsub(event, 6)
	
	-- Special events
	if event == "UNIT_DIED" then
		actionString = TUTORIAL_TITLE25 .. ": "
	elseif event == "UNIT_DESTROYED" then
		actionString = ACTION_UNIT_DESTROYED .. ": "
	elseif event == "ENCHANT_APPLIED" or event == "ENCHANT_REMOVED" then
		actionString = ENSCRIBE .. ": "
		offset = 0
		spellName = select(base + offset + 1, ...)
		itemID = select(base + offset + 2, ...)
		itemName = select(base + offset + 3, ...) or 1
	elseif event == "PARTY_KILL" then
		spellName = ACTION_PARTY_KILL
	elseif event == "DAMAGE_SHIELD" or event == "DAMAGE_SPLIT" then
		offset = 3
		prefix = "SPELL"
		suffix = "_DAMAGE"
	elseif event == "DAMAGE_SHIELD_MISSED" then
		offset = 3
		prefix = "SPELL"
		suffix = "_MISSED"
	else
		actionString = ""
	end
	
	if prefix == "SWING" then
		offset = 0
		spellName = MELEE
	elseif prefix == "SPELL" or prefix == "RANGE" then
		offset = 3
		spellName = select(11, ...)
		school = select(12, ...)
	elseif prefix == "ENVIR" then
		offset = 1
		srcUnitName = destUnitName
		srcFlags = destFlags
		destUnitName = nil
		destFlags = nil
		local environmentalType = select(base + offset, ...)
		spellName = L[environmentalType]
		suffix = "_DAMAGE"
	end
	if suffix == "_DAMAGE" then
		amount = select(base + offset + 1, ...)
		overkill = select(base + offset + 2, ...)
		school = select(base + offset + 3, ...) or 1
		resisted = select(base + offset + 4, ...)
		blocked = select(base + offset + 5, ...)
		absorbed = select(base + offset + 6, ...) --(nil if 0)
		critical = select(base + offset + 7, ...) --(1 or nil)
		glancing = select(base + offset + 8, ...) --(1 or nil)
		crushing = select(base + offset + 9, ...) --(1 or nil)
	elseif suffix == "_MISSED" then
		missType = select(base + offset + 1, ...)
		amountMissed = select(base + offset + 2, ...)
	elseif suffix == "_HEAL" then
		amount = select(base + offset + 1, ...)
		overhealing = select(base + offset + 2, ...)
		critical = select(base + offset + 3, ...)
	elseif suffix == "_ENERGIZE" then
		amount = select(base + offset + 1, ...)
		powerType = select(base + offset + 2, ...)
	elseif suffix == "_DRAIN" or suffix == "_LEECH" then
		amount = select(base + offset + 1, ...)
		powerType = select(base + offset + 2, ...)
		extraAmount = select(base + offset + 3, ...)
	elseif suffix == "_INTERRUPT" or suffix == "_DISPEL" or suffix == "_DISPEL_FAILED" or suffix == "_STOLEN" or suffix == "_AURA_BROKEN_SPELL" then
		--extraSpellID = select(base + offset + 1, ...)
		extraSpellName = select(base + offset + 2, ...)
		extraSchool = select(base + offset + 3, ...)
		auraType = select(base + offset + 4, ...)
	elseif suffix == "_EXTRA_ATTACKS" then
		amount = select(base + offset + 1, ...)
	elseif suffix == "_AURA_APPLIED" or suffix == "_AURA_REMOVED" or suffix == "_AURA_APPLIED_DOSE" or suffix == "_AURA_REMOVED_DOSE" or suffix == "_AURA_REFRESH" or suffix == "_AURA_BROKEN" then
		auraType = select(base + offset + 1, ...)
		amount = select(base + offset + 2, ...)
	elseif suffix == "_CAST_FAILED" then
		failedType = select(base + offset + 1, ...)
	end
	
	
	-- Process strings
	if srcUnitName then
		local str
		local coloredUnitStr
		local leftBrace
		local rightBrace
		if db.colorSrc then
			local color = self:AffiliationColor(srcFlags)
			coloredUnitStr = "|cFF" .. color .. srcUnitName .. "|r"
		end
		if db.colorSrcBraces then
			leftBrace = "|cFF" .. db.leftSrcBraceColor .. db.leftSrcBrace .. "|r"
			rightBrace = "|cFF" .. db.rightSrcBraceColor .. db.rightSrcBrace .. "|r"
		else
			leftBrace = db.leftSrcBrace
			rightBrace = db.rightSrcBrace
		end
		if db.braceSrcUnit then
			str = leftBrace .. "%s" .. rightBrace .. " "
		end
		srcUnitNameString = format(str or "%s ", coloredUnitStr or srcUnitName)
	else
		srcUnitNameString = ""
	end

	if db.prefix then
		local str
		if suffix == "_AURA_APPLIED" or suffix == "_AURA_APPLIED_DOSE" then
			str = db["++"]
		elseif suffix == "_AURA_REMOVED" or suffix == "_AURA_REMOVED_DOSE" then
			str = db["--"]
		elseif suffix == "_AURA_REFRESH" then
			str = db["-+"]
		elseif suffix == "_CAST_START" then
			str = L["begins"]
		elseif suffix == "_CAST_SUCCESS" then
			str = L["casts"]
		else
			str = ""
		end
		if db.colorPrefix and (str ~= "") then
			local color = self:ColorSpellBySchool(school, auraType, event) or "FFFFFF"
			prefixString = format("|cFF%s%s|r ", color, str)
		elseif (str ~= "") then
			prefixString = str .. " "
		else
			prefixString = str
		end
	else
		prefixString = ""
	end
	
	if spellName then
		local coloredSpell
		local bracedSpell
		local leftBrace
		local rightBrace
		if db.colorSpell then
			local color = self:ColorSpellBySchool(school, auraType, event) or "FFFFFF"
			coloredSpell = "|cFF" .. color .. spellName .. "|r"
		else
			coloredSpell = spellName
		end
		if db.braceSpell then
			if db.colorSpellBraces then
				leftBrace = "|cFF" .. db.leftSpellBraceColor .. db.leftSpellBrace .. "|r"
				rightBrace = "|cFF" .. db.rightSpellBraceColor .. db.rightSpellBrace .. "|r"
			else
				leftBrace = db.leftSpellBrace
				rightBrace = db.rightSpellBrace
			end
			
			bracedSpell = (leftBrace) .. "%s" .. (rightBrace) .. " "
		else
			bracedSpell = "%s "
		end
		spellNameString = format(bracedSpell, coloredSpell)
	else
		spellNameString = ""
	end
	
	if db.suffixString then
		local str
		local result
		if suffix == "_HEAL" then
			str = L.Heal
		elseif suffix == "_PERIODIC_HEAL" then
			str = L.Regen
		elseif suffix == "_PERIODIC_DAMAGE" then
			str = L.Dot
		elseif suffix == "_DISPEL" or suffix == "_DISPEL_FAILED" then
			str = L.Dispel
		end
		
		if missType == "MISS" then
			str = db.format.MISS
		end
		
		if str then
			suffixString = str .. " "
		else
			suffixString = ""
		end
	else
		suffixString = ""
	end
	
	if destUnitName then
		local str
		local coloredUnitStr
		local leftBrace
		local rightBrace
		if db.colorDest then
			local color = self:AffiliationColor(destFlags)
			coloredUnitStr = "|cFF" .. color .. destUnitName .. "|r"
		end
		if db.colorDestBraces then
			leftBrace = "|cFF" .. db.leftDestBraceColor .. db.leftDestBrace .. "|r"
			rightBrace = "|cFF" .. db.rightDestBraceColor .. db.rightDestBrace .. "|r"
		else
			leftBrace = db.leftDestBrace
			rightBrace = db.rightDestBrace
		end
		if db.braceDestUnit then
			str = leftBrace .. "%s" .. rightBrace .. " "
		end
		destUnitNameString = format(str or "%s ", coloredUnitStr or destUnitName)
	else
		destUnitNameString = ""
	end
	
	if amount then
		local str
		local amountResult
		local coloredAmountStr
		local leftBrace
		local rightBrace
		local leftDot
		local rightDot
		local leftCrit
		local rightCrit
		
		if db.overhealing and type(overhealing) == "number" and overhealing > 0 then
			amountResult = amount - overhealing .. "(+" .. overhealing .. ")"
		elseif db.overkill and type(overkill) == "number" and overkill > 0 then
			amountResult = amount - overkill .. "(+" .. overkill .. ")"
		else
			amountResult = amount
		end
		
		if suffix == "_ENERGIZE" or suffix == "_PERIODIC_ENERGIZE" then
			amountResult = "+ " .. amountResult
		end
		
		
		if db.colorAmount and school then
			local color = self:ColorSpellBySchool(school, auraType, event)
			coloredAmountStr = "|cFF" .. color .. amountResult .. "|r"
		end
		if db.braceAmount then
			if db.colorAmountBraces then
				leftBrace = "|cFF" .. db.leftAmountBraceColor .. db.leftAmountBrace .. "|r"
				rightBrace = "|cFF" .. db.rightAmountBraceColor .. db.rightAmountBrace .. "|r"
			else
				leftBrace = ""
				rightBrace = ""
			end
			str = "%s%s" .. leftBrace .. "%s" .. rightBrace .. "%s%s" .. " "
		end
		if db.braceAmountDots and suffix == "_PERIODIC_DAMAGE" or suffix == "_PERIODIC_HEAL" then
			if colorAmountDotBraces then
				leftDot = "|cFF" .. leftAmountDotBraceColor .. db.leftAmountDotsBrace .. rightAmountDotBraceColor .. "|r"
				leftDot = "|cFF" .. leftAmountDotBraceColor .. db.rightAmountDotsBrace .. rightAmountDotBraceColor .. "|r"
			else
				leftDot = db.leftAmountDotsBrace
				rightDot = db.rightAmountDotsBrace
			end
		else
			leftDot = ""
			rightDot = ""
		end
		if db.markCrits and critical then
			leftCrit = db.leftCrit
			rightCrit = db.rightCrit
		else
			leftCrit = ""
			rightCrit = ""
		end
		amountNameString = format(str or "%s%s%s%s%s ", leftCrit, leftDot, coloredAmountStr or amountResult, rightDot, rightCrit)
	else
		amountNameString = ""
	end
	if extraSpellName then
		local color = self:ColorSpellBySchool(extraSchool)
		amountNameString = "|cFF" .. color .. extraSpellName .. "|r "
	end
	if itemName then
		amountNameString = itemName
	end
	
	if db.powerType and powerType then
		powerString = string.lower(powerType) .. " "
	else
		powerString = ""
	end
	
	if db.schoolText and school then
		local coloredSchool
		local bracedSchool
		if db.colorSchoolText then
			local color = self:ColorSpellBySchool(school)
			coloredSchool = "|cFF" .. color .. schools[school] .. "|r"
		else
			coloredSchool = schools[school]
		end
		if db.braceSchoolText then
			if db.colorSchoolTextBraces then
				local color = self:ColorSpellBySchool(school)
				bracedSchool = "|cFF" .. color .. db.schoolTextBraceLeft .. "|r" .. coloredSchool .. "|cFF" .. color .. db.schoolTextBraceRight .. "|r"
			else
				bracedSchool = db.schoolTextBraceLeft .. coloredSchool .. db.schoolTextBraceRight
			end
		else
			bracedSchool = coloredSchool
		end
		schoolStr = bracedSchool
	else
		schoolStr = ""
	end
	
	if db.resultString then
		if missType == "RESIST" then
			resisted = amountMissed
		elseif missType == "BLOCK" then
			blocked = amountMissed
		elseif missType == "ABSORB" then
			absorbed = amountMissed
		elseif missType ~= "MISS" then
			resultString = db.format[missType]
		end
			
		if suffix == "_DISPEL_FAILED" then
			resultString = L.failed
		end
		
		if not resultString then resultString = self:DamageResult(resisted, blocked, absorbed, critical, glancing, crushing) end
	end
	
	finalString = actionString .. srcUnitNameString .. prefixString .. spellNameString .. suffixString .. destUnitNameString .. amountNameString .. powerString .. schoolStr .. resultString
	--_G[db.outputFrame]:AddMessage(finalString)
	return finalString
end
